#include "DBManager.h"

int DBManager::db_init=0;
int DBManager::count=0;
DBManager *DBManager::db_mgr=NULL;


DBManager :: DBManager()
{

}
DBManager :: ~DBManager()
{

	for(int i=0;i<DB_CONN_POOL;i++){
		db_conn_obj *dbc = DB_POOL[i];
		mysql_close(dbc->conn);
		pthread_mutex_destroy(&(dbc->lock));
		free(dbc);
	
	}


}

void DBManager:: initializePool(struct db_config *dbc)
{
	for(int i=0;i<DB_CONN_POOL;i++){
		MYSQL* conn = mysql_init(NULL);
		/* Connect to database */
		if (!mysql_real_connect(conn, dbc->server,
			dbc->user, dbc->password, dbc->database, 0, NULL, 2)) {
			fprintf(stderr, "%s\n", mysql_error(conn));
	        	return ;
		}else {
			db_conn_obj *dbconn = new db_conn_obj();
			dbconn->conn=conn;
			pthread_mutex_init(&(dbconn->lock), NULL);
			printf("initialized %d connection\n",i);
			DB_POOL[i]=dbconn;
		}	
   	}
}



DBManager* DBManager::getInstance()
{
	if(db_init==0){
		db_mgr=new DBManager();
		DBManager::db_init=1;
	}
	return db_mgr;
}

MYSQL_RES *DBManager::read_query(db_conn_obj* dbc,char* query)
{
	MYSQL_RES *res;
	pthread_mutex_lock(&(dbc->lock));
	if(dbc==NULL)
	cout << "null connection" << endl;

	if(dbc->conn==NULL)
	cout << "null connection" << endl;

	if (mysql_real_query(dbc->conn, query,strlen(query))) {
		fprintf(stderr, "%s\n", mysql_error(dbc->conn));
		pthread_mutex_unlock(&(dbc->lock));
		return NULL;
	}
	mysql_commit(dbc->conn);
        res = mysql_store_result(dbc->conn);
	pthread_mutex_unlock(&(dbc->lock));
	return res;
}


long DBManager::write_query(db_conn_obj* dbc,char* query)
{
	pthread_mutex_lock(&(dbc->lock));
	if (mysql_query(dbc->conn, query)) {
		fprintf(stderr, "%s\n", mysql_error(dbc->conn));
	pthread_mutex_unlock(&(dbc->lock));
      		return -1;
	}
   	long rows = (unsigned long) mysql_affected_rows(dbc->conn);
	pthread_mutex_unlock(&(dbc->lock));
	return rows;
}


db_conn_obj* DBManager::getConnectionObj()
{
	db_conn_obj *dbm = DB_POOL [DBManager::count%DB_CONN_POOL];
	DBManager::count++;
	return dbm;
}
