#define DB_CONN_POOL 10
#include <mysql.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>
#include <iostream>
using namespace std;
typedef struct db_conn_obj {
	MYSQL *conn;
	pthread_mutex_t lock;
} db_conn_obj;

typedef struct db_config {
	char server[64];
	char user[16];
	char password[16];
	char database[16];
}db_config;

class DBManager {

	public :

		static DBManager* getInstance();

		db_conn_obj* getConnectionObj();
		void initializePool(struct db_config*);

		/*caller frees the result set and query string*/
		MYSQL_RES * read_query(db_conn_obj* dbc,char* query);
		/*caller frees the query string*/
		long write_query(db_conn_obj* dbc,char* query);

	protected :

	private :
		DBManager();
		~DBManager();
		static DBManager *db_mgr;
		static int db_init;
		static int count;
		db_conn_obj* DB_POOL[DB_CONN_POOL];

};

