#include "PolicyDB.h"
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <iostream>
#include <unistd.h>

/* Usage()
 * Specifies command line parameters required
 */
 
void Usage () {
  
    cerr<<"Usage : PolicyDB -p <presentity> -f <policyfile> -d <database> -m <machine> -u <username> -e <password> "<<endl;

}/* Usage() */

/* main(int argc,char *argv[])
 * Main program to transfer a policy file  to database 
 */ 
int main(int argc,char *argv[]) {
   
   char *presentity = NULL ;
   char *policy_file = NULL;	
   char option;   
   char *database = NULL;
   char *machine = NULL;
   char *user = NULL;
   char *password = NULL; 
   		
   if (argc < 2) {
        Usage();
        return 1;
    }
	
	
    while((option=getopt(argc,argv,"p:f:d:m:u:e:"))!= -1) {
        switch(option) {
        case 'p':
            presentity  = optarg;
       
            break;
        case 'f':
            policy_file = optarg;
          
            break;
        case 'd':
            database = optarg;
         
            break;
        case 'm':
            machine = optarg;
            
            break;
        case 'u':
            user = optarg;
           
            break;
        case 'e':
            password = optarg;
           
            break;
        case '?':
            if (isprint(optopt))
                fprintf(stderr,"Unknown option '%c\n'",optopt);
            else
                fprintf(stderr,"Unknown option character '\\x%x'\n",optopt);
            Usage();
            exit(1);
            break;
        default:
            Usage();
            exit(1);
            break;
        }
    }

    if(database == NULL) {
        printf("Please enter database\n");
        Usage();
        exit(1);
        
    }
    

   FILE *fp = fopen(policy_file,"r");
   int file_size,num;

   if(fp==NULL) {
     cerr<<"No such file %s"<<policy_file<<endl;
   }
   char *str;
   fseek(fp,0,SEEK_END);
   file_size = ftell(fp);
   rewind(fp);
   str = (char *)calloc(file_size,sizeof(char));
   num = fread(str,1,file_size-1,fp);
   printf("%s\n",str);

   PolicyDB *db = new PolicyDB(presentity,database,machine,user,password);
   
                                     
   if(db->parsePolicyDocument(str)) {
     cout<<"Successfully Done!!"<<endl;
   }
   else {
     cerr<<"Error somewhere !!"<<endl;
   }
   fclose(fp);
}/* main(int argc,char *argv[]) */
