/**
 * PolicyQuery.h: This handles all MYSQL queries for filtering
 * Copyright 2005 by Columbia University; all rights reserved
 */

#ifndef POLICY_QUERY_H
#define POLICY_QUERY_H

#include <mysql.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>
#include <iostream>
#include "DBManager.h"

using namespace std;

class PolicyQuery {

	public :
            
            PolicyQuery(char *database,char *machine,char *user,char *password);
                            
            void insert_ruleidentity(char *presentity,char *ruleid,char *one_id,char *scheme,char *except_id,char *except_scheme,char *except_domain,char *many_domain);
            void insert_ruleset(char *presentity,char *ruleid,char *sphere,char *validity_from,char *validity_to,char *subhandling,char *provide_all_services,char *provide_all_devices,char *provide_all_persons,char *provide_activities,char *provide_class,char *provide_device_id,char *provide_mood,char *provide_place_type,char *provide_place_is,char *provide_privacy,char *provide_relationship,char *provide_status_icon,char *provide_sphere,char *provide_time_offset,char *provide_user_input,char *provide_note,char *provide_unknown_attribute,char *unknown_attribute_name);
            void insert_servicepermission(char *presentity,char *ruleid,char *service_type,char *service_value);
            void insert_devicepermission(char *presentity,char *ruleid,char *device_type,char *device_value);
            void insert_personpermission(char *presentity,char *ruleid,char *person_type,char *person_value);
	    void verify_presentity(char *presentity);
            void cleanup_tables(char *presentity);
            MYSQL_RES* rule_combine(string ruleid_set,char *presentity);
            MYSQL_RES* getsubscription(string ruleid_set,char *presentity);
            MYSQL_RES* select_devicepermission(char *presentity,string ruleid_set);
            MYSQL_RES* select_ruleidentity(char *presentity,char *identity,char *domain,char *scheme);
            MYSQL_RES* select_rulematch(char *presentity,char *ruleid,char *sphere);
            MYSQL_RES* select_personpermission(char *presentity,string ruleid_set);
            MYSQL_RES* select_servicepermission(char *presentity,string ruleid_set);
            ~PolicyQuery();
	protected :

	private :
	   
            DBManager *dbm;
            db_conn_obj *dbc;
         
            
 };

#endif
