/**
 * PrivacyFilter.h: Handles filtering of the presence document 
 * Copyright 2005 by Columbia University; all rights reserved
 */

#ifndef PRIVACY_FILTER_H
#define PRIVACY_FILTER_H

#include <xercesc/parsers/XercesDOMParser.hpp>
#include <xercesc/dom/DOM.hpp>
#include <xercesc/sax/HandlerBase.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/framework/MemBufInputSource.hpp>
#include <xercesc/framework/MemBufFormatTarget.hpp>
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/parsers/AbstractDOMParser.hpp>
#include <xercesc/dom/DOMImplementation.hpp>
#include <xercesc/dom/DOMImplementationLS.hpp>
#include <xercesc/dom/DOMImplementationRegistry.hpp>
#include <xercesc/dom/DOMBuilder.hpp>
#include <xercesc/dom/DOMException.hpp>
#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMNodeList.hpp>
#include <xercesc/dom/DOMError.hpp>
#include <xercesc/dom/DOMAttr.hpp>
#include <xercesc/dom/DOMNamedNodeMap.hpp>
#include <xercesc/util/XMLString.hpp>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string>
#include "PrivacyRuleMatch.h"

XERCES_CPP_NAMESPACE_USE
                                                                                
using namespace std;

class PrivacyFilter {
    
    public : 
         
        PrivacyFilter(char *presentity,char *subscriber,char *domain,char *scheme,char *sphere);
        ~PrivacyFilter();
        DOMNode *doFilter(DOMDocument *policydoc);
        char *serializeDOM(DOMNode *node); 
   
    protected:
       
        void apply_filter(DOMNode *node);
        void filter_node(DOMNode *node);
        void delete_node(DOMNode *node); 
        bool is_node_name(DOMNode *node, const char* name) ;
        char * get_node_value(DOMNode *node);
	

    private : 

       
        final_rule *matched_rule;
      
        
};   

#endif    








