/**
 * SubscriptionAuthorization.h: API for getting final subscription authorization for a subscriber 
 * Copyright 2005 by Columbia University; all rights reserved
 */

#ifndef SUBAUTH_H
#define SUBAUTH_H

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <mysql.h>
#include <list>
#include <iterator>
#include <string>
#include <iostream>
#include "PolicyQuery.h"

using namespace std;

class SubscriptionAuthorization {

    public :
        
         SubscriptionAuthorization();
        ~SubscriptionAuthorization();
        int getAuthorization(char *presentity, char *watcher, char *domain, char*scheme, char *sphere);
    protected :

        
        string convert_list_to_string(list<const char *> ruleid_list);
        list<const char *> getRuleidList(char *presentity,char *identity,char *domain, char *scheme,char *sphere,list<const char*> &);

    private :
        
       
        PolicyQuery *query;
    

};    

#endif
